/*
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <POURRIER Thibaud> wrote this file. As long as you retain this notice you
 * can do whatever you want with this stuff. If we meet some day, and you think
 * this stuff is worth it, you can buy me a beer in return.
 * Poul-Henning Kamp.
 * ----------------------------------------------------------------------------
 */

/******************************************************************************
		"screen4b.h"
		This file is the header of "screen4b.c".
		/!\ WARNING: This file is modified for the project INSOLED /!\
*******************************************************************************/


#ifndef screen4bh
#define screen4bh

	#define SCR_2x8	// Comment this line if your screen is a 2x16 caracters screen


	// Libraries
	#include <string.h>
	#include <stdlib.h>

	//------------------ Macros ----------------------
	#define EN_ON		PORTD |= _BV(PD5)	// Register Select
	#define EN_OFF		PORTD &= ~_BV(PD5)
	#define RS_ON		PORTD |= _BV(PD4)	// Enable
	#define RS_OFF		PORTD &= ~_BV(PD4)
	#define DATA		PORTB				// DB0..3
	#define CLEAR_DATA	DATA &= 0xF0		// Delete DATA

	#define CURSOR_ON	Write_cmd(0b00001110)
	#define CURSOR_OFF	Write_cmd(0b00001100)
	
	#define NOTHING		42

	//------------------ Prototypes ------------------
	void Write_cmd(unsigned char byte);
	void Write_char(unsigned char data, unsigned char add);
	#ifdef SCR_2x8
		void Write_str(char str[16], unsigned char add);
	#else
		void Write_str(char str[32], unsigned char add);
	#endif
	void Write_nbr(int nbr, unsigned char add, uchar mode);
	void Write_error(unsigned char error_num, char description[32]);
	void Init_screen(void);
	void Clear_screen(void);
	void Return_home(void);

#endif //#define screen4bh

